//+------------------------------------------------------------------+
//|                                                    ATR_Bands.mq4 |
//| ATR Bands are self-adjusting enveloppes, based on the volatility |
//|        Based on BB indicator, modified by kris.pivo[at]gmail.com |
//+------------------------------------------------------------------+
#property copyright " 2008, Kris"
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  White
#property indicator_style1  STYLE_DASH
#property indicator_color2  Gold
#property indicator_color3  Gold
#property indicator_color4  Magenta
#property indicator_color5  RoyalBlue
//---- indicator parameters

int    Lag;
extern int    NumberOfComputations =   2;
extern int    NumberOfBars         = 2000;
extern int    Price                = PRICE_MEDIAN;
extern int    Bands_Shift          = 0;
extern int    ATR_Period           = 5;
extern double ATR_Multiplier       = 1.5;
int    T3_Period;
extern double b                    = 1.00;
extern double timefactor           = 1;// 1=timeframe used, if higher tf for instance on 1hr chart want h4 band timefactor should =4 
extern int    TimeFrame            = 0;   //Time Frame in min
extern color  LineColor            = Yellow;
extern int    FuzzR                =  255;
extern int    FuzzG                =  0;
extern int    FuzzB                =  0;
extern int    VisualMode           =  0;   //0-DC+Corona,1-DC,2-Corona 
extern int    CoronaBars           =  1000;
//---- buffers
double MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];
double UpperBuffer2[];
double LowerBuffer2[];
double UpperBuffer3[];
double LowerBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle( 0,DRAW_LINE,STYLE_DASH,0,indicator_color1);
   SetIndexBuffer(0,MovingBuffer);
   SetIndexStyle( 1,DRAW_LINE,STYLE_SOLID,1,indicator_color2);
   SetIndexBuffer(1,UpperBuffer);
   SetIndexStyle( 2,DRAW_LINE,STYLE_SOLID,1,indicator_color3);
   SetIndexBuffer(2,LowerBuffer);
   SetIndexStyle( 3,DRAW_LINE,STYLE_SOLID,1,indicator_color4);
   SetIndexBuffer(3,UpperBuffer2);
   SetIndexStyle( 4,DRAW_LINE,STYLE_SOLID,1,indicator_color5);
   SetIndexBuffer(4,LowerBuffer2);
   SetIndexStyle( 5,DRAW_LINE,STYLE_SOLID,1,indicator_color4);
   SetIndexBuffer(5,UpperBuffer3);
   SetIndexStyle( 6,DRAW_LINE,STYLE_SOLID,1,indicator_color5);
   SetIndexBuffer(6,LowerBuffer3);
//----
   SetIndexDrawBegin(0,Lag+Bands_Shift);
   SetIndexDrawBegin(1,Lag+Bands_Shift);
   SetIndexDrawBegin(2,Lag+Bands_Shift);
   SetIndexDrawBegin(4,Lag+Bands_Shift);
   SetIndexDrawBegin(5,Lag+Bands_Shift);
   SetIndexDrawBegin(6,Lag+Bands_Shift);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();
   double TrueRange;
   double sum,oldval,newres;
   Lag = iCustom(NULL,0,"CoronaCyclePeriod_v2.1",Price,LineColor,FuzzR,FuzzG,FuzzB,VisualMode,CoronaBars,0,i)/2*timefactor;
   T3_Period = iCustom(NULL,0,"CoronaCyclePeriod_v2.1",Price,LineColor,FuzzR,FuzzG,FuzzB,VisualMode,CoronaBars,0,i)/2*timefactor; 
//----
   if(Bars<=Lag) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=Lag;i++)
        {
         MovingBuffer[Bars-i]=EMPTY_VALUE;
         UpperBuffer[Bars-i]=EMPTY_VALUE;
         LowerBuffer[Bars-i]=EMPTY_VALUE;
         UpperBuffer2[Bars-i]=EMPTY_VALUE;
         LowerBuffer2[Bars-i]=EMPTY_VALUE;
         UpperBuffer3[Bars-i]=EMPTY_VALUE;
         LowerBuffer3[Bars-i]=EMPTY_VALUE;
        }
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      MovingBuffer[i]=iCustom(NULL,0,"SSAofprice",Lag ,NumberOfComputations,NumberOfBars,Price,0,i);
//----
   i=Bars-Lag+1;
   if(counted_bars>Lag-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      sum=0.0;
      k=i+Lag-1;
      oldval=MovingBuffer[i];
      TrueRange=ATR_Multiplier*iCustom(NULL,0,"ATR_T3_v1.2",ATR_Period,T3_Period,b,false,0,i);
      UpperBuffer[i]=oldval+TrueRange;
      LowerBuffer[i]=oldval-TrueRange;
      UpperBuffer2[i]=oldval+TrueRange*2;
      LowerBuffer2[i]=oldval-TrueRange*2;
      UpperBuffer3[i]=oldval+TrueRange*3;
      LowerBuffer3[i]=oldval-TrueRange*3;
      i--;
     }
//----
   return(0);
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
//                                       THE END                                        |
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

